import pyjd # this is dummy in pyjs

from pyjamas.ui.Button import Button
from pyjamas.ui.RootPanel import RootPanel
from pyjamas.ui.HTML import HTML
from pyjamas.ui.DockPanel import DockPanel
from pyjamas.ui import HasAlignment
from pyjamas.ui.Hyperlink import Hyperlink
from pyjamas.ui.VerticalPanel import VerticalPanel
from pyjamas import Window
from SinkList import SinkList
from Configure import TopPanel
from pyjamas import History
import Welcome
import Slices
import Identities
import PlanetLab
import PLE
import PLJ
import GpENI
import VINI
import OpenCirrus
import SfaBrowser
import Configure

class SfaGUI:
    def onHistoryChanged(self, token):
        info = self.sink_list.find(token)
        if info:
            self.show(info, False)
        else:
            self.showInfo()

    def onModuleLoad(self):
        self.tp = TopPanel()
        self.tp.setWidth("100%")

        self.curInfo=''
        self.curSink=None
        self.description=HTML()
        self.sink_list=SinkList()
        self.panel=DockPanel()
        self.loadSinks()
        self.sinkContainer = DockPanel()
        self.sinkContainer.setStyleName("ks-Sink")

        vp=VerticalPanel()
        vp.setWidth("100%")
        vp.setHeight("100%")
        vp.add(self.description)
        vp.add(self.sinkContainer)

        self.description.setStyleName("ks-Info")

        self.panel.add(self.tp, DockPanel.NORTH)
        self.panel.add(self.sink_list, DockPanel.WEST)
        self.panel.add(vp, DockPanel.CENTER)

        self.panel.setCellVerticalAlignment(self.sink_list, HasAlignment.ALIGN_TOP)
        self.panel.setCellWidth(vp, "100%")
        self.panel.setCellHeight(vp, "100%")

        History.addHistoryListener(self)
        RootPanel().add(self.panel)

        #Show the initial screen.
        initToken = History.getToken()
        if len(initToken):
            self.onHistoryChanged(initToken)
        else:
            self.showInfo()

    def show(self, info, affectHistory):
        if info == self.curInfo: return
        self.curInfo = info

        if self.curSink <> None:
            self.curSink.onHide()
            self.sinkContainer.remove(self.curSink)

        self.curSink = info.getInstance()
        self.sink_list.setSinkSelection(info.getName())
        self.description.setHTML(info.getDescription())

        if (affectHistory):
            History.newItem(info.getName())

        self.sinkContainer.add(self.curSink, DockPanel.CENTER)
        self.sinkContainer.setCellWidth(self.curSink, "100%")
        self.sinkContainer.setCellHeight(self.curSink, "100%")
        self.sinkContainer.setCellVerticalAlignment(self.curSink, HasAlignment.ALIGN_TOP)
        self.curSink.onShow()
        
    def loadSinks(self):
        self.sink_list.addSink(Welcome.init())
        #self.sink_list.addSink(Identities.init())
        # self.sink_list.addSink(Slices.init())
        self.sink_list.addSink(PlanetLab.init())
        self.sink_list.addSink(PLE.init())
        self.sink_list.addSink(PLJ.init())
        self.sink_list.addSink(GpENI.init())
        self.sink_list.addSink(VINI.init())
        #self.sink_list.addSink(OpenCirrus.init())
        self.sink_list.addSink(SfaBrowser.init())
        self.sink_list.addSink(Configure.init())

    def showInfo(self):
        self.show(self.sink_list.find("Welcome"), False)




if __name__ == '__main__':
    pyjd.setup("public/SfaGUI.html")
    app = SfaGUI()
    app.onModuleLoad()
    pyjd.run()
